#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"


class Deb:public MicroAG{
public:  
  Deb(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};
void Deb::evalua(int *cromosoma,double *aptitud){
  double f;
  double g;
  double h;
  double x1=decodifica(0,cromosoma);
  double x2=decodifica(1,cromosoma);

  f=x1;
  g=11+pow(x2,2)-10*cos(2*3.1415926*x2);
  if(f<=g)
    h=1-pow((f/g),(double)(1.0/2.0));
  else
    h=0;
  aptitud[0]=f;
  aptitud[1]=g*h;
}
void Deb::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    /*
      double fenotipo=0.0,x1,x2;
      int j;
      int *cadena,*pb;
      cadena=gray_A_binario(ind[i].genotipo);
      pb=cadena;
      for(j=0;j<14;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j],j);//de las potencias de dos reespectivas y
      x1=fenotipo*1/(pow(base,14)-1); 
    
      fenotipo=0.0;
      for(j=0;j<20;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j+14],j);//de las potencias de dos reespectivas y
      delete cadena;
      x2=-30+fenotipo*60/(pow(base,20)-1); 
    
    
      archivo<<x1;
      archivo<<"\t";
      archivo<<x2;
      archivo<<"\n";
    */
  }
}

int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=700;
  int M=4;
  int nTope=2;
  int nGenes=2;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7,Pm=(double)1.0/34.0;
  double *linf=new(double[2]);//=0.1;
  double *lsup=new(double[2]);//=1;
  int *pres=new(int[2]);//=4;
  linf[0]=0.0;
  linf[1]=-30.0;
  lsup[0]=1.0;
  lsup[1]=30.0;
  pres[0]=4;
  pres[1]=4;
  int sndelit=50;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);

  Deb mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,0,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}


