#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
/*
MOP 3 con el que se probo el NSGA II
Funcion de Poloni
 */

class Poloni:public MicroAG{
public:  
  Poloni(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};
void Poloni::evalua(int *cromosoma,double *aptitud){
  double sum1=0,sum2=0;
  double x=decodifica(0,cromosoma);
  double y=decodifica(1,cromosoma);

  double A1=0.5*sin(1)-2*cos(1)+sin(2)-1.5*cos(2);
  double A2=1.5*sin(1)-cos(1)+2*sin(2)-0.5*cos(2);
  double B1=0.5*sin(x)-2*cos(x)+sin(y)-1.5*cos(y);
  double B2=1.5*sin(x)-cos(x)+2*sin(y)-0.5*cos(y);
  
  aptitud[0]=1+pow(A1-B1,2)+pow(A2-B2,2);
  aptitud[1]=pow(x+3,2)+pow(y+1,2);
}

void Poloni::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    for(int r=0;r<nObjs;r++)
      archivo<<ind[i].aptObj[r]*-1<<"\t";
    // almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    /*
    
      double x=decodifica(0,ind[i].genotipo);
      double y=decodifica(1,ind[i].genotipo);
      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}

int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=1000;
  int M=4;
  int nTope=5;
  int nGenes=2;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.3;
  double Pm=(double)1.0/28.0;
  double *linf=new(double[2]);
  double *lsup=new(double[2]);
  int *pres=new(int[2]);
  linf[0]=0.0;
  linf[1]=0.0;
  lsup[0]=1.0;
  lsup[1]=1.0;
  pres[0]=4;
  pres[1]=4;
  int sndelit=50;
  double pNRem=0.3;

  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);
  
   Poloni mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}


